local addonName, addon, ns = ...
addon.addonTitle = GetAddOnMetadata(addonName, "Title")
addon.exclamation = "|TInterface\\OptionsFrame\\UI-OptionsFrame-NewFeatureIcon:0:0:0:-1|t"
local buffs = CreateFrame("frame")
buffs:RegisterEvent("ADDON_LOADED")
buffs:RegisterEvent("PLAYER_ENTERING_WORLD")
buffs:RegisterEvent("PLAYER_TARGET_CHANGED")
buffs:RegisterEvent("PLAYER_FOCUS_CHANGED")
buffs:RegisterEvent("UNIT_AURA")
buffs:SetScript("OnEvent", function(self, event)
    self:ColorBuffs();
    self:ColorAuras();
end)

addon.optionsTable = {
	name = addon.addonTitle,
	type = "group",
	args = {
		title = {
			order = 1,
			type = "description",
			fontSize = "large",
			name = "Warcraft" .. " " .. addon.addonTitle .. " Texture Pack v" .. GetAddOnMetadata(addonName, "Version")
		},
		descriptionx = {
			order = 2,
			type = "description",
			fontSize = "small",
			name = "Latest update: 27th August 2023 for game version 10.1.5.50791 (If your Texture Pack version is older than that please download and update your files. To check your version go to World Of Warcraft/retail/Interface and open version.txt file) "
		},
		break3 = {
			order = 3,
			type = "header",
			name = ""
		},
		descriptiona = {
			order = 4,
			type ="description",
			fontSize = "medium",
			name = "IMPORTANT! If your Dark Textures are not working read below:",
		},
		description = {
			order = 5,
			type ="description",
			fontSize = "medium",
			name = "Thank you for downloading Dark Theme Texture Pack but there is few steps before you can enjoy your dark UI. Since its Texture Pack and not an AddOn you will need to follow a guide with few steps below to get there. Texture Pack is group of files which I can not upload to any AddOn manager (like CurseForge etc.) so I created this small AddOn with a guide to how to install it. You can visit CurseForge Dark Theme page for links straight to the download page",
		},
		break2 = {
			order = 8,
			type = "header",
			name = ""
		},
		break7 = {
			order = 7,
			type = "header",
			name = ""
		},
		title2 = {
			order = 8,
			type = "description",
			fontSize = "large",
			name = addon.exclamation.. "|cff00c0ffInstallation Guide|r"
		},
		break6 = {
			order = 9,
			type = "header",
			name = ""
		},
		description2 = {
			order = 10,
			type ="description",
			fontSize = "medium",
			name = "Step 1. Download the texture pack from https://github.com/nyko7/World-Of-Warcraft-Dark-Theme-UI-Texture-Pack. You can download it by clicking on 'Code' button and 'Download ZIP'. (Clickable links in CurseForge AddOn description)",
		},
		break4 = {
			order =11,
			type = "header",
			name = ""
		},
		description3 = {
			order = 12,
			type ="description",
			fontSize = "medium",
			name = "Step 2. Unpack the ZIP file and copy folders to your Interface folder inside your World Of Warcraft directory right next to AddOn folder. Careful!!! NOT inside AddOn folder, its not an AddOn",
		},
		break5 = {
			order = 13,
			type = "header",
			name = ""
		},
		description4 = {
			order = 14,
			type ="description",
			fontSize = "medium",
			name = "Step 3. Congrats you made it. Load the game and enjoy the Texture Pack and once again thank you for downloading. If you still struggling to make it work try looking into CurseForge AddOn description where you can find a screenshot of an example how your Interface files should look with DarkTheme installed correctly.",
		},
		break9 = {
			order = 15,
			type = "header",
			name = ""
		},
		breaka = {
			order = 16,
			type = "header",
			name = ""
		},
		title8 = {
			order = 17,
			type = "description",
			fontSize = "large",
			name = addon.exclamation.. "|cff00c0ffQuick tip|r"
		},
		break10 = {
			order = 18,
			type = "header",
			name = ""
		},
		description6 = {
			order = 19,
			type ="description",
			fontSize = "medium",
			name = "If you get AddOn update on CurseForge AddOn manager or any other WoW AddOn manager that means that something was updated inside Texture Pack too. So you will need to repeat the installation process again which includes downloading the Texture Pack again. But dont worry it wont be often until Blizzard adds some new textures.",
		},
		breakb = {
			order = 20,
			type = "header",
			name = ""
		},
		breakc = {
			order = 21,
			type = "header",
			name = ""
		},
		title9 = {
			order = 22,
			type = "description",
			fontSize = "large",
			name = addon.exclamation.. "|cff00c0ffJoin Discord for help|r"
		},
		breakd = {
			order = 23,
			type = "header",
			name = ""
		},
		description7 = {
			order = 24,
			type ="description",
			fontSize = "medium",
			name = "Discord is work in progress. We will update it soon.",
		},
		breake = {
			order = 25,
			type = "header",
			name = ""
		},
		description8 = {
			order = 26,
			type ="description",
			fontSize = "medium",
			name = " ",
		},
	},
}


LibStub("AceConfig-3.0"):RegisterOptionsTable(addonName, addon.optionsTable)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions(addonName, addon.addonTitle)
LibStub("AceConfigDialog-3.0"):SetDefaultSize(addonName, 550, 640)

local function OnProfileChange()
	for mod, _ in pairs(addon.modules) do
		addon.modules[mod].db = addon.db.profile[mod]
	end
end	

function buffs:ColorBuffs()
    
    local iconSize = 35;
    local iconPadding = BuffFrame.AuraContainer.iconPadding;
    local texture = MultiBarBottomRightButton1NormalTexture:GetAtlas()
    
    for _, value in ipairs({ BuffFrame.AuraContainer:GetChildren() }) do
        
        if not value.styled and value.Icon then
            iconSize = value.Icon:GetSize() + 1;
            value.Icon:SetSize(iconSize - 2.2, iconSize - 2.2);
            value.Icon:SetTexCoord(.05, .95, .05, .95);
            value.default = CreateFrame("Frame", "AuraBorderTexture", value)
            value.default:SetSize(iconSize + iconPadding, iconSize + iconPadding)
            value.default:SetPoint("CENTER", value.Icon, "CENTER", 2, -2);
            value.default.texture = value.default:CreateTexture("BuffBorderTexture", "OVERLAY");
            value.default.texture:SetAllPoints()
            value.default.texture:SetAtlas(texture)
            value.default.texture:SetVertexColor(1, 1, 1, 1)
            value.styled = true;
        end

        if (not value.default) then return end
        
        if (value.Border and value.Border:IsShown()) then
            value.default:Hide();
        else
            value.default:Show();
        end
    end
end

function buffs:ColorAuras()
    
    local texture = MultiBarBottomRightButton1NormalTexture:GetAtlas()
    
    local function BuffsDarkBorder(frame)
        local frameName = frame:GetName();
        
        for _, value in pairs({ frame:GetChildren() }) do
        
            if not value.styled and value.Icon then
                local iconSize = value.Icon:GetSize();
                value.default = CreateFrame("Frame", frameName .. "AuraBorderTexture", value);
                value.default:SetSize(iconSize + 4, iconSize + 4);
        
                if (value:GetName() == frameName .. "SpellBar") then
                    value.default:SetPoint("RIGHT", v, "LEFT", 2, -7);
                else
                    value.default:SetPoint("TOPLEFT", value, "TOPLEFT", 0, 0);
                    value.default:SetPoint("BOTTOMRIGHT", value, "BOTTOMRIGHT", 3, -3);
                end
        
                if (value.Count) then
                    value.Count:SetPoint("BOTTOMRIGHT", value, "BOTTOMRIGHT", 1, 0);
                end
        
                value.default.texture = value.default:CreateTexture(nil, "OVERLAY");
                value.default.texture:SetAllPoints();
                value.default.texture:SetAtlas(texture);
                value.default.texture:SetVertexColor(1, 1, 1, 1);
                value.styled = true;
        
            elseif ((value.styled and value.Stealable and value.Stealable:IsShown()) or
                (value.styled and value.Border and value.Border:IsShown())) then
                value.default:Hide();
        
            elseif (value.styled) then
                value.default:Show()
                local iconSize = value.Icon:GetSize();
                value.default:SetSize(iconSize + 5, iconSize + 5);
            end
        end
    end

    BuffsDarkBorder(TargetFrame);

    if (not FocusFrame.smallSize) then
        BuffsDarkBorder(FocusFrame);
    end
end

